#include "StdAfx.h"
#include ".\order.h"

ostream& operator<<(ostream& os, const Order& order)
{
    os << "Order Number " << order.ordernumber << ": " << order.quantity << " of item " << order.itemnumber << endl;
    return os;
}



Order::Order(void) : ordernumber(-1), itemnumber(-1), quantity(0)
{
}

Order::Order(int on, int in, int q): ordernumber(on), itemnumber(in), quantity(q)
{
}

Order::~Order(void)
{
}
