// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;
using namespace System::Threading;

int maxCount;

public __gc class Counter
{
public:
	void Countdown()
	{
		String* threadName = Thread::CurrentThread->Name;
		Console::Write(S"This is the current thread:  ");
		Console::WriteLine(threadName);
		for (int counter = maxCount; counter >= 1; counter--)
		{
			Console::WriteLine(S"{0} is currently on {1}.",threadName, __box(counter));
		}
		Console::WriteLine(S"{0} has finished counting down from {1}.", threadName, 
				__box(maxCount));
	}
};

int _tmain()
{
	Console::Write("Enter a number to count down from:  ");
	maxCount = Int16::Parse(Console::ReadLine());
	Thread::CurrentThread->Name = "Main Thread";

	Counter* counter = new Counter();
	ThreadStart* SecondStart = new ThreadStart(counter,Counter::Countdown);
	Thread* secondThread = new Thread(SecondStart);
	secondThread->Name = "Secondary Thread";
	secondThread->Start();

	counter->Countdown();

	Console::ReadLine();
	return 0;
}