using System;
using  System.Runtime.InteropServices;

namespace CSUseLegacyDLL
{
    struct SYSTEMTIME 
    {
        public short wYear;
        public short wMonth;
        public short wDayOfWeek;
        public short wDay;
        public short wHour;
        public short wMinute;
        public short wSecond;
        public short wMilliseconds;
    } 

	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
        static SYSTEMTIME MakeSystemTimeFromDateTime(DateTime dt)
        {
            SYSTEMTIME st;
            st.wYear = (short) dt.Year;
            st.wMonth = (short) dt.Month;
            st.wDayOfWeek = (short) dt.DayOfWeek;
            st.wDay = (short) dt.Day;
            st.wHour = (short) dt.Hour;
            st.wMinute = (short) dt.Minute;
            st.wSecond = (short) dt.Second;
            st.wMilliseconds = (short) dt.Millisecond;

            return st;
        }		
          
        [DllImport("legacy.dll", CharSet=CharSet.Ansi)]
        static extern bool Log(String message, ref SYSTEMTIME time);

        [DllImport("legacy.dll")]
        static extern double Add(double num1, double num2);
 
        /// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
            System.Console.Write("1 + 2 is ");
            System.Console.WriteLine( Add(1,2));
            String s = "Testing with a C# string";
            SYSTEMTIME st = MakeSystemTimeFromDateTime(DateTime.Now);
	        Log(s, ref st);
	        System.Console.WriteLine("log succeeded");
		}
	}
}
