// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;

int _tmain()
{
	Microsoft::Office::Interop::Word::Application* ap = new Microsoft::Office::Interop::Word::ApplicationClass();
	Object* missing = System::Reflection::Missing::Value;

	//to get suggestions, there must be a document
	if (ap->Documents->Count == 0)
		ap->Documents->Add(&missing,&missing,&missing,&missing); 

	Console::WriteLine("Enter a sentence and press enter:");
	String* testSentence;
	testSentence = Console::ReadLine();

	String* delims = S"\t,() ";
	Char delimiter[] = delims->ToCharArray();
	String* words[] = 0;
	words = testSentence->Split(delimiter);
	System::Collections::IEnumerator* nextword = words->GetEnumerator();
	while (nextword->MoveNext()) 
	{
		String* s = __try_cast<String*>(nextword->Current);

		bool spellingOK = ap->CheckSpelling(s,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing);
		if (!spellingOK)
		{
			Console::WriteLine("{0} is not recognized by Word. Word suggests:",s);
			Microsoft::Office::Interop::Word::SpellingSuggestions* sugg  = ap->GetSpellingSuggestions(s,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing,&missing);
			int suggcount = sugg->Count;
			for (int i = 1; i <= suggcount; i++)
			{
				Microsoft::Office::Interop::Word::SpellingSuggestion* suggestedword = sugg->get_Item(i);
				if (suggestedword)
				{
					Console::WriteLine(suggestedword->Name);
				}
			}
			if (suggcount == 0)
				Console::WriteLine("No suggestions.");
		}
	}
	Object* donotsave = __box(Microsoft::Office::Interop::Word::WdSaveOptions::wdDoNotSaveChanges);
	ap->get_ActiveWindow()->Close(&donotsave,&missing);

	return 0;
}