// ATLUtilities.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
// For custom assert and trace handling with WebDbg.exe
#ifdef _DEBUG
CDebugReportHook g_ReportHook;
#endif

#include "ATLUtilities.h"
#include ".\atlutilities.h"
[ module(name="MyATLUtilities", type="dll") ]
class CDllMainOverride
{
public:
	BOOL WINAPI DllMain(DWORD dwReason, LPVOID lpReserved)
	{
#if defined(_M_IX86)
		if (dwReason == DLL_PROCESS_ATTACH)
		{
			// stack overflow handler
			_set_security_error_handler( AtlsSecErrHandlerFunc );
		}
#endif
		return __super::DllMain(dwReason, lpReserved);
	}
};

[ emitidl(restricted) ];

STDMETHODIMP ATLUtilitiesService::CATLUtilitiesService::Factor(SHORT i, DOUBLE d, VARIANT_BOOL* result)
{
    int j = (int)( i / d);
    *result = (j*d == i);

    return S_OK;
}
