#include "StdAfx.h"
#include ".\employee.h"
#using <mscorlib.dll>

using namespace EmployeeData;

using namespace System::Data::OleDb;
using namespace System::Text;

Employee::Employee(void)
{
    ConnStr = Configuration::ConfigurationSettings::AppSettings->get_Item("connstr"); 
}

Employee::~Employee(void)
{
}

DataSet* Employee::Lookup(String* name)
{
    DataSet* ds = new DataSet("Employees");

    StringBuilder* query = new StringBuilder();
    query->Append("SELECT * FROM Employees WHERE EmployeeName Like '%");
    query->Append(name);
    query->Append("%'");

    OleDbDataAdapter* adapter = new OleDbDataAdapter(query->ToString(), ConnStr);

    try
    {
        adapter->Fill(ds,"Employees");
    }
    catch (OleDbException* e)
    {
        Console::WriteLine("OleDbException caught while filling the dataset");
        Console::WriteLine(e->Message);
    }
    return ds;
}

IDataReader* Employee::LookupReader(String* name)
{
    StringBuilder* query = new StringBuilder();
    query->Append("SELECT * FROM Employees WHERE EmployeeName Like '%");
    query->Append(name);
    query->Append("%'");

    OleDbConnection* conn = new OleDbConnection(ConnStr);
    OleDbCommand* SelectCommand = new OleDbCommand(query->ToString(),conn);
    conn->Open();
    return SelectCommand->ExecuteReader(Data::CommandBehavior::CloseConnection);
}

void Employee::Update(DataSet* newrecords)
{
    OleDbDataAdapter* adapter = new OleDbDataAdapter("SELECT * FROM Employees", ConnStr);
    OleDbCommandBuilder* cb = new OleDbCommandBuilder(adapter);

    adapter->Update(newrecords, "Employees");
}