#pragma once

#include "remotehandler.h"

namespace GreetingClient
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary> 
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class Form1 : public System::Windows::Forms::Form
	{	
    private:
        Greeting::Greeter* greet;
	public:
		Form1(void)
		{
			InitializeComponent();
            Runtime::Remoting::RemotingConfiguration::Configure("GreetingClient.exe.config");
			Runtime::Remoting::Channels::ChannelServices::RegisterChannel(new Runtime::Remoting::Channels::Tcp::TcpServerChannel("callback", 9556));

			greet = new Greeting::Greeter();
            RemoteHandler* rh = new RemoteHandler();
            try
            {
                Greeting::RemoteHandlerBase* rhb = static_cast<Greeting::RemoteHandlerBase*>(rh);
                greet->RemoteAlertEvent += new RemoteAlert(rhb, &RemoteHandler::Alert);
            }
            catch (Exception* e)
            {
            }
		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
    private: System::Windows::Forms::Button *  Greet;
    private: System::Windows::Forms::Button *  GreetName;
    private: System::Windows::Forms::TextBox *  Namebox;

    private: System::Windows::Forms::Button *  GetRecords;
    private: System::Windows::Forms::Label *  Greeting;
    private: System::Windows::Forms::DataGrid *  RecordsGrid;


	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container * components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
            this->Greet = new System::Windows::Forms::Button();
            this->GreetName = new System::Windows::Forms::Button();
            this->Namebox = new System::Windows::Forms::TextBox();
            this->RecordsGrid = new System::Windows::Forms::DataGrid();
            this->GetRecords = new System::Windows::Forms::Button();
            this->Greeting = new System::Windows::Forms::Label();
            (__try_cast<System::ComponentModel::ISupportInitialize *  >(this->RecordsGrid))->BeginInit();
            this->SuspendLayout();
            // 
            // Greet
            // 
            this->Greet->Location = System::Drawing::Point(48, 24);
            this->Greet->Name = S"Greet";
            this->Greet->TabIndex = 0;
            this->Greet->Text = S"Greet";
            this->Greet->Click += new System::EventHandler(this, Greet_Click);
            // 
            // GreetName
            // 
            this->GreetName->Location = System::Drawing::Point(48, 64);
            this->GreetName->Name = S"GreetName";
            this->GreetName->TabIndex = 1;
            this->GreetName->Text = S"Greet Name";
            this->GreetName->Click += new System::EventHandler(this, GreetName_Click);
            // 
            // Namebox
            // 
            this->Namebox->Location = System::Drawing::Point(144, 72);
            this->Namebox->Name = S"Namebox";
            this->Namebox->TabIndex = 2;
            this->Namebox->Text = S"";
            // 
            // RecordsGrid
            // 
            this->RecordsGrid->DataMember = S"";
            this->RecordsGrid->Dock = System::Windows::Forms::DockStyle::Bottom;
            this->RecordsGrid->HeaderForeColor = System::Drawing::SystemColors::ControlText;
            this->RecordsGrid->Location = System::Drawing::Point(0, 129);
            this->RecordsGrid->Name = S"RecordsGrid";
            this->RecordsGrid->Size = System::Drawing::Size(384, 144);
            this->RecordsGrid->TabIndex = 3;
            // 
            // GetRecords
            // 
            this->GetRecords->Location = System::Drawing::Point(48, 104);
            this->GetRecords->Name = S"GetRecords";
            this->GetRecords->Size = System::Drawing::Size(80, 23);
            this->GetRecords->TabIndex = 4;
            this->GetRecords->Text = S"Get Records";
            this->GetRecords->Click += new System::EventHandler(this, GetRecords_Click);
            // 
            // Greeting
            // 
            this->Greeting->Location = System::Drawing::Point(144, 24);
            this->Greeting->Name = S"Greeting";
            this->Greeting->Size = System::Drawing::Size(216, 23);
            this->Greeting->TabIndex = 5;
            // 
            // Form1
            // 
            this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
            this->ClientSize = System::Drawing::Size(384, 273);
            this->Controls->Add(this->Greeting);
            this->Controls->Add(this->GetRecords);
            this->Controls->Add(this->RecordsGrid);
            this->Controls->Add(this->Namebox);
            this->Controls->Add(this->GreetName);
            this->Controls->Add(this->Greet);
            this->Name = S"Form1";
            this->Text = S"Form1";
            (__try_cast<System::ComponentModel::ISupportInitialize *  >(this->RecordsGrid))->EndInit();
            this->ResumeLayout(false);

        }	
    private: System::Void Greet_Click(System::Object *  sender, System::EventArgs *  e)
             {
                 Greeting->Text = greet->Greet();
             }

    private: System::Void GreetName_Click(System::Object *  sender, System::EventArgs *  e)
             {
                 Greeting->Text = greet->Greet(Namebox->Text);
             }

private: System::Void GetRecords_Click(System::Object *  sender, System::EventArgs *  e)
         {
             Data::DataSet* ds = greet->Records();
             RecordsGrid->DataSource = ds->Tables->get_Item(0);
         }  
};
}


