using namespace System;
using namespace System::Text::RegularExpressions;

namespace control
{
public __gc class NumbersOnlyTextBox : 
    public System::Windows::Forms::TextBox
{
private:
    bool IsValid(String* Contents)
    {
        Regex* re = new Regex("\\d*");
        Match* m; 
        m = re->Match(Contents);
        bool test = m->Success 
               && m->Index == 0 
               && m->Length == Contents->Length;
        if (!test)
            System::Windows::Forms::MessageBox::Show("enter only numbers here");
        return test;
    }
public:
    [System::ComponentModel::Browsable(false)]
     __property bool get_Valid() 
    {
        return IsValid(Text);
    }
protected:
    void OnValidating(System::ComponentModel::CancelEventArgs* e)
    {
        if (!Valid)
            e->Cancel = true;
    System::Windows::Forms::TextBox::OnValidating(e);
    return;
    }

};
}