// Interop.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
using namespace std;


#import "ManagedMathLibrary.tlb"  exclude("allocator<void>", \
	"basic_string<char,std::char_traits<char>,std::allocator<char> >", \
	"codecvt<unsigned short,char,int>", \
	"ctype<char>", \
	"ctype<unsigned short>", \
	"basic_ostream<unsigned short,std::char_traits<unsigned short> >", \
	"basic_ostream<char,std::char_traits<char> >", \
	"basic_istream<unsigned short,std::char_traits<unsigned short> >", \
	"basic_istream<char,std::char_traits<char> >", \
	"allocator<char>", \
	"_DebugHeapAllocator<char>", \
	"basic_string<char,std::char_traits<char>,std::_DebugHeapAllocator<char> >", \
	"basic_ios<unsigned short,std::char_traits<unsigned short> >", \
	"basic_streambuf<unsigned short,std::char_traits<unsigned short> >", \
	"fpos<int>", \
	"basic_ios<char,std::char_traits<char> >", \
	"basic_streambuf<char,std::char_traits<char> >", \
	"_String_val<char,std::allocator<char> >", \
	"_String_val<char,std::_DebugHeapAllocator<char> >", \
    "ostreambuf_iterator<char,std::char_traits<char> >", \
    "num_put<char,std::ostreambuf_iterator<char,std::char_traits<char> > >", \
    "numpunct<char>")



int _tmain(int argc, _TCHAR* argv[])
{
    ::CoInitialize(NULL);

    ManagedMathLibrary::IDllPtr dll("ManagedMathLibrary.DLL");
     
    dll->Initialize();
    ManagedMathLibrary::IArithmeticPtr a("ManagedMathLibrary.Arithmetic");
    cout << "2.3 + 4.5 is " <<  a->Add(2.3, 4.5) << endl;
    dll->Cleanup();
    ::CoUninitialize();

	return 0;
}

