// ManagedMathLibrary.h

#pragma once

#include <iostream>
using namespace std;

// windows.h is for _vcclrit.h -kmg
#include <windows.h>
#include <_vcclrit.h>

using namespace System;

#include "simple.h"


namespace ManagedMathLibrary
{
    public __gc __interface IDll
    {
		void Initialize();
		void Cleanup();
    };

    public __gc class DLL: public IDll
	{
	public:
		void Initialize()
		{
			__crt_dll_initialize();
		}
		void Cleanup()
		{
			__crt_dll_terminate();
		}
	};

    public __gc __interface IArithmetic
    {
		System::Double Add(System::Double num1, System::Double num2);
		System::Double Subtract(System::Double num1, System::Double num2);
		System::Double Divide(System::Double num1, System::Double num2);
		System::Double Multiply(System::Double num1, System::Double num2);
    };

public __gc class Arithmetic : public IArithmetic
	{
	public:
		
		System::Double Add(System::Double num1, System::Double num2)
		{

			Simple s(2);
			cout << endl << "Simple is " << s.getx() << endl;
			cout << endl << "I am in Add" << endl;
			return num1 + num2;
		}
		System::Double Subtract(System::Double num1, System::Double num2)
		{
			return num1 - num2;
		}
		System::Double Divide(System::Double num1, System::Double num2)
		{
			return num1 / num2;
		}
		System::Double Multiply(System::Double num1, System::Double num2)
		{
			return num1 * num2;
		}
	};
}
